$(function() {
	var kacaArr;
	var kacaSmer;
	var mis;
	var konec = true;
	var konecPromise;

	//1. ustvarimo tabelo
	var visina = 30;
	var sirina = 30;	
	for (let i = 0; i < visina; i++) {
		let row = $("<tr>");
		for (let j = 0; j < sirina; j++) {
			let cell = $("<td>");
			row.append(cell);
		}
		$("#povrsina").append(row);
	}

	function pocakaj(ms) {
		return new Promise(function (resolve) {
			timeout = setTimeout(() => resolve(kacaSmer), ms);
			$(document).off("keydown").on("keydown", function(e){
				$(document).off("keydown");
				if (e.keyCode == 37) { 
					if (kacaSmer != "desno") resolve("levo");
				} else if (e.keyCode == 38) {
					if (kacaSmer != "dol") resolve("gor");
				} else if (e.keyCode == 39) {
					if (kacaSmer != "levo") resolve("desno");
				} else if (e.keyCode == 40) {
					if (kacaSmer != "gor") resolve("dol");
				}				
				return false;
			});
		});
	}

	function igralnaCelica(tocka) {
		return $("#povrsina tr").eq(tocka.y)
							.children()
							.eq(tocka.x);
	}

	// izris
	function izris() {
		$("#povrsina td").removeClass();
		
		let glava = igralnaCelica(kacaArr[0]);
		let tockaRep = kacaArr[kacaArr.length-1];
		let rep = igralnaCelica(tockaRep);
		let tockaPredRep = kacaArr[kacaArr.length-2];
				
		glava.addClass('glava').addClass(kacaSmer);
		rep.addClass('rep');

		if (tockaRep.x == tockaPredRep.x+1)
			rep.addClass('desno');
		else if (tockaRep.x == tockaPredRep.x-1)
			rep.addClass('levo');
		else if (tockaRep.y == tockaPredRep.y-1)
			rep.addClass('gor');
		else
			rep.addClass('dol');
		
		// za telo
		for (let i = 1; i < kacaArr.length-1; i++) {
			igralnaCelica(kacaArr[i]).addClass('telo');
		}
		
		// izris miši
		if (mis.x != -1) igralnaCelica(mis).addClass("mis");
	}

	function obstajaTocka(tocka) {
		return kacaArr.some(t => t.x == tocka.x && t.y == tocka.y);
	}

	function kacaZraste() {
		let tg = kacaArr[0];
		let novaGlava;
		if (kacaSmer == "levo") {
			if (tg.x == 0) return false;
			novaGlava = {x:tg.x-1, y:tg.y};
		} else if (kacaSmer == "desno") {
			if (tg.x == sirina-1) return false;
			novaGlava = {x:tg.x+1, y:tg.y};
		} else if (kacaSmer == "gor") {
			if (tg.y == 0) return false;
			novaGlava = {x:tg.x, y:tg.y-1};
		} else if (kacaSmer == "dol") {
			if (tg.y == visina-1) return false;
			novaGlava = {x:tg.x, y:tg.y+1};
		}		
		if (obstajaTocka(novaGlava)) return false;
		kacaArr.unshift(novaGlava);
		return true;
	}
	
	function kacaPremik() {
		if (!kacaZraste()) return false; // dodamo pri glavi
		kacaArr.pop(); // zmanjsamo pri repu
		if (obstajaTocka(mis)) {
			if (!kacaZraste()) return false;
			$("#velikost").text(kacaArr.length);
			initMis();
		}
		izris();
		return true;
	}
	
	function nakljucniInt(min, max) {
		return Math.floor(Math.random() * (max - min + 1)) + min;
	}
	
	function dodajMis() {
		while (true) {
			mis = {x:nakljucniInt(0, sirina-1), y:nakljucniInt(0,visina-1)};
			if (!obstajaTocka(mis)) break;
		}		
		izris();
	}

	function initMis() {
		mis = {x:-1, y:-1};
		izris();
	}

	function init() {
		// podatkovna struktura kače
		// glava prvi element, rep zadnji
		kacaArr = [
			{
				x: Math.round(sirina/2)-1,
				y: Math.round(visina/2)-1
			},
			{
				x: Math.round(sirina/2),
				y: Math.round(visina/2)-1
			},
		];
		
		initMis();
		// smer premikanja kace
		kacaSmer = "levo";
				
		$("#velikost").text(kacaArr.length);
				
		izris();
		
		$(document).off("keydown").on("keydown", function(e){
			$(document).off("keydown");
			if (e.keyCode >= 37 && e.keyCode <= 40) {
				if (e.keyCode == 37) { 
					kacaSmer = "levo";
				} else if (e.keyCode == 38) {
					kacaSmer = "gor";
				} else if (e.keyCode == 39) {
					kacaSmer = "desno";
				} else if (e.keyCode == 40) {
					kacaSmer = "dol";
				}			
				start();
				dodajajMisi();
			}
			return false;
		});		
	}

	async function start() {
		konec = false;
		while (true) {
			if (kacaPremik()) {
				kacaSmer = await pocakaj(100);
			} else {
				konec = true;
				konecPromise();
				var ime = prompt("Vpišite ime");
				
				var pozicija = $('#lestvica td:nth-child(2)')
				.map(function() { return $(this).text();})
				.get()
				.map(t => parseInt(t))
				.findIndex(t => t < kacaArr.length);
				
				if (pozicija == -1) pozicija = $("#lestvica").children().length-1;
				
				let vrstica = $("<tr>");
				$("<td>").text(ime).appendTo(vrstica);
				$("<td>").text(kacaArr.length).appendTo(vrstica);
				$("#lestvica").children().eq(pozicija).after(vrstica);
				
				init();
				break;
			}			
		}		
	}

	async function dodajajMisi() {
		while (true) {
			dodajMis();
			await new Promise(t => {konecPromise=t; setTimeout(t, 5000);});
			if (konec) break;
			initMis();
			// pocakamo nakljucno
			await new Promise(t => {konecPromise=t; setTimeout(t, nakljucniInt(1,3)*1000);});
			if (konec) break;
		}
	}
	
	init();
})
